Name: rhevm-sdk-java
Version: 3.5.0.5
Release: 5%{?dist}
Summary: RHEVM Engine Java Software Development Kit
Group: Development/Libraries
License: ASL 2.0
URL: http://www.ovirt.org/Java-sdk

# git clone git://gerrit.ovirt.org/ovirt-engine-sdk-java
# cd ovirt-engine-sdk-java
# git archive --prefix=ovirt-engine-sdk-java-3.5.0.5/ --format=tar 3.5.0.5 | xz > ovirt-engine-sdk-java-3.5.0.5.tar.xz
Source0: ovirt-engine-sdk-java-%{version}.tar.xz

# This Ant build file is part of the downstream build process, for
# environments where Maven isn't available:
Source1: build.xml

# These patches are required in order to build the SDK so that it can be
# used with Java 6:
Patch0: 0001-Revert-sdk-implement-AutoCloseable.patch
Patch1: 0002-Revert-sdk-maven-compile-with-jdk-1.7.patch

# Regenerate against the latest API:
Patch2: 0003-Regenerate-against-the-latest-API.patch

BuildArch: noarch

BuildRequires: ant >= 1.7
BuildRequires: apache-commons-beanutils >= 1.8.3
BuildRequires: httpcomponents-httpclient >= 4.2.1
BuildRequires: httpcomponents-httpcore >= 4.2.1
BuildRequires: java-devel
BuildRequires: jpackage-utils
BuildRequires: log4j >= 1.2.14

Requires: apache-commons-beanutils >= 1.8.3
Requires: httpcomponents-httpclient >= 4.2.1
Requires: httpcomponents-httpcore >= 4.2.1
Requires: java
Requires: jpackage-utils
Requires: log4j >= 1.2.14

# This package and the corresponding upstream package use the same
# paths and files, so they can't be installed together:
Conflicts: ovirt-engine-sdk-java

%description
This package contains The RHEVM-Engine Java Software Development Kit.
With this package, custom java software can be built for RHEVM-Engine.

%package javadoc
Summary: Javadocs for %{name}
Group: Documentation
Requires: jpackage-utils

%description javadoc
This package contains the API documentation for %{name}.

%prep

# Unpack the source:
%setup -q -n ovirt-engine-sdk-java-%{version}

# Apply the patches:
%patch0 -p1
%patch1 -p1
%patch2 -p1

%build

# The source contains a directory for the code generator and another for
# the SDK itself, but all what is relevant to this package is in the
# second one:
cd ovirt-engine-sdk-java

# Copy the Ant build script to the directory containing the source of
# the SDK:
cp %{SOURCE1} build.xml

# Populate the lib directory with symlinks to the required dependencies that
# will be used to create the compiler classpath:
mkdir lib
while read jar
do
  ln -s $(build-classpath ${jar}) lib/.
done <<.
commons-beanutils
httpclient
httpcore
log4j
.

# Perform the build using Ant:
ant

%install
install -d -m 755 %{buildroot}%{_javadir}/%{name}

install -pm 644 ovirt-engine-sdk-java/target/%{name}.jar %{buildroot}%{_javadir}/%{name}/%{name}-%{version}.jar
ln -s %{name}-%{version}.jar %{buildroot}%{_javadir}/%{name}/%{name}.jar

mkdir -p %{buildroot}%{_javadocdir}/%{name}
install -pm 644 ovirt-engine-sdk-java/target/%{name}-javadoc.jar %{buildroot}%{_javadocdir}/%{name}/%{name}-%{version}-javadoc.jar
ln -s %{name}-%{version}-javadoc.jar %{buildroot}%{_javadocdir}/%{name}/%{name}-javadoc.jar

%files
%{_javadir}/%{name}/
%doc ovirt-engine-sdk-java/AUTHORS.md
%doc ovirt-engine-sdk-java/README.md
%doc ovirt-engine-sdk-java/LICENSE.md

%files javadoc
%{_javadocdir}/%{name}

%changelog
* Tue Dec 2 2014 Juan Hernandez <juan.hernandez@redhat.com> - 3.5.0.5-5
- Add support for template custom properties #1011735.

* Tue Nov 4 2014 Juan Hernandez <juan.hernandez@redhat.com> - 3.5.0.5-4
- Add snapshot id to snapshot preview action #1155656.

* Wed Oct 15 2014 Juan Hernandez <juan.hernandez@redhat.com> - 3.5.0.5-3
- Add support for memory ballooning #1149188.
- Add support for unregistered VMs #1148715.

* Mon Oct 6 2014 Juan Hernandez <juan.hernandez@redhat.com> - 3.5.0.5-2
- Replace storage_manager with spm #1146457.

* Wed Sep 10 2014 Juan Hernandez <juan.hernandez@redhat.com> - 3.5.0.5-1
- Update to upstream 3.5.0.5.
- Added support for watchdog action and model #1129840.

* Wed Sep 3 2014 Juan Hernandez <juan.hernandez@redhat.com> - 3.5.0.4-1
- Update to upstream 3.5.0.4.
- Added support for network QoS.
- Added support to enable/disable sound card to VM, pool and template.

* Wed Aug 27 2014 Juan Hernandez <juan.hernandez@redhat.com> - 3.5.0.3-1
- Update to upstream version 3.5.0.3.
- Added support for QoS, including CPU and disk profiles.
- Added support for iSCSI bonds.

* Wed Jul 23 2014 Juan Hernandez <juan.hernandez@redhat.com> - 3.5.0.2-1
- Update to upstream version 3.5.0.2.
- Avoid NPE when receiving null lists #1119812.
- Fix optional parameters of add template #1109548.
- Fix parameters of add DataCenter #1104085.
- Fix update VM optional parameters #1082594.

* Wed Jul 9 2014 Juan Hernandez <juan.hernandez@redhat.com> - 3.5.0.1-1
- Update to upstream version 3.5.0.1.
- Added NUMA support.
- Added actions to copy and move disks #1097681.
- Added file_transfer_enabled and copy_paste_enabled elements to Display.
- Added protocol element to Host.
- Added support for Gluster volume profiling.
- Added support for instance types.
- Added support for quota.id parameter for disks.
- Added support for random number generator device.
- Added support for scheduling policies.
- Added support storage domains disks sub-collection.
- Added support to register VMs and templates.
- Support X-Ovirt-Expect header #1093784.

* Thu Jul 3 2014 Juan Hernandez <juan.hernandez@redhat.com> - 3.5.0.0-1
- Update to upstream version 3.5.0.0.
- Regenerate for version 3.5 of the engine.
- Added action to undelete events.
- Added base_interface to host_nic.
- Added boot_menu to VM and template.
- Added custom properties to host_nic.
- Added disksnapshots sub-collection to storagedomains.
- Added domain_entry_id to users and groups.
- Added sessions sub-collection to vms.
- Added support for Gluster volume statistics.
- Added support for VM and template custom serial numbers.
- Added support for bookmarks.
- Added support for deleting VM disk snapshots.
- Added support for reporting VM SELinux configuration.
- Added support for reporting VM kdump configuration.
- Added support for reporting architecture capabilities.
- Added tags sub-collection to templates.
- Add method to get entity by string id #1099818.

* Tue Jun 24 2014 Juan Hernandez <juan.hernandez@redhat.com> - 3.4.1.2-1
- Update to upstream 3.4.1.2.
- Add method to get entity by string id #1101425.

* Wed Apr 30 2014 Juan Hernandez <juan.hernandez@redhat.com> - 3.4.1.0-2
- Added maintenance operation to VM.
- Added hosted_engine element to Host.
- Added labels to Network.
- Added labels to HostNIC.

* Wed Apr 23 2014 Juan Hernandez <juan.hernandez@redhat.com> - 3.4.1.0-1
- Update to upstream 3.4.1.0.
- Added actions to preview, commit and undo snapshots.
- Added support for affinity groups.
- Added support to import a VM as template.
- Removed external_id from users and groups.
- Renamed cloud_init.hostname to cloud_init.host.address.

* Tue Apr 1 2014 Juan Hernandez <juan.hernandez@redhat.com> - 3.4.0.7-3
- Regenerate agains latest API.
- Added support for affinity groups.
- Added support to import image as template.
- Added preview, commit and undo operations to snapshots.

* Thu Mar 20 2014 Juan Hernandez <juan.hernandez@redhat.com> - 3.4.0.7-2
- Several changes to the build system, no change to the code.

* Thu Mar 13 2014 Juan Hernandez <juan.hernandez@redhat.com> - 3.4.0.7-1
- Added overloads for new headers #1073417.

* Fri Feb 28 2014 Juan Hernandez <juan.hernandez@redhat.com> - 3.4.0.6-1
- Removed ip.mtu parameter from host NIC update operation #1049611.

* Thu Feb 27 2014 Juan Hernandez <juan.hernandez@redhat.com> - 3.4.0.5-1
- Added template versions support.

* Wed Feb 12 2014 Juan Hernandez <juan.hernandez@redhat.com> - 3.4.0.2
- Add the allContent parameter to relevant action methods.

* Fri Jan 24 2014 Juan Hernandez <juan.hernandez@redhat.com> - 3.4.0.1
- Don't add parameters with null values #1047638

* Mon Dec 16 2013 Juan Hernandez <juan.hernandez@redhat.com> - 1.0.0.29-1
- Build for Java 1.6 #1043465

* Tue  Dec 10 2013 Michael Pasternak <mpastern@redhat.com> - 1.0.0.28-1
- to vms.add() added [action.vm.initialization.cloud-init] 
- to NIC added OnBoot/BootProtocol properties
- to VersionCaps added a list of supported payload-encodings

* Tue  Nov 26 2013 Michael Pasternak <mpastern@redhat.com> - 1.0.0.27-1
- to VnicProfile added Permissions sub-collection #1014985
- from VMSnapshot removed actions: preview, undo, commit #1018554
- to VnicProfilePermission added delete() method overload (with correlation_id)

* Tue  Oct 29 2013 Michael Pasternak <mpastern@redhat.com> - 1.0.0.26-1
- to host.install() added ssh related details
- to template added virtio_scsi.enabled
- to vm added virtio_scsi.enabled
- added ability to attach a disk snapshot to the virtual machine

* Tue  Oct 22 2013 Michael Pasternak <mpastern@redhat.com> - 1.0.0.25-1
- to File.java added 'content' filed
- Payload.java now reuses Files instead of own List<PayloadFile> collection

* Tue  Oct 8 2013 Michael Pasternak <mpastern@redhat.com> - 1.0.0.24-1
- rename /export actions
- added fqdn property to GuestInfo

* Tue  Sep 24 2013 Michael Pasternak <mpastern@redhat.com> - 1.0.0.23-1
- to Disk added export() action
- Template.exportTemplate() renamed to Template.export()
- VM.exportVM() renamed to VM.export()

* Tue  Sep 17 2013 Michael Pasternak <mpastern@redhat.com> - 1.0.0.22-1
- refine host add()/update() documentation
- update functions doesn't have overloading methods #1008176
- setupnetworks doesn't work #1008458
- apache PropertyUtilsBean throws NoSuchMethodException #1007266
- session_timeout parameter doesnt exists in API constructor #1007231
- maven compile with jdk 1.7

* Wed  Sep 11 2013 Michael Pasternak <mpastern@redhat.com> - 1.0.0.21-1
- VCpuPin renamed to VCpuPin
- Host.getRebootAfterInstallation() returns False (null was expected) #985842
- make all sdk exceptions serializable

* Tue  Sep 3 2013 Michael Pasternak <mpastern@redhat.com> - 1.0.0.20-1
- added StorageDomainStorageConnection.delete() signature
- added StorageDomainStorageConnection.delete(Boolean async) signature
- added StorageDomainStorageConnections.add(StorageConnection storageconnection) signature
- added StorageDomainStorageConnections.add(StorageConnection storageconnection, String expect, String correlationId) signature

* Tue  Aug 27 2013 Michael Pasternak <mpastern@redhat.com> - 1.0.0.19-1
- add ParameterSet descriptions
- implement AutoCloseable interface
- in Cluster added glusterhooks (ClusterGlusterHooks) sub-collection
- in DataCenterCluster added glusterhooks (DataCenterClusterGlusterhooks)
  sub-collection
- in StorageDomain added images (StorageDomainImages) sub-collection

* Tue  Aug 13 2013 Michael Pasternak <mpastern@redhat.com> - 1.0.0.18-1
- added VnicProfiles root-collection
- at network added VnicProfiles sub-collection
- at storagedomain added StorageConnections sub-collection
- at VnicProfile added Permission sub-collection
- to network.add()/.updated added [network.profile_required]
- to NICs.add() added new overload with [nic.vnic_profile.id]
- to NIC.update() added new overload with [nic.vnic_profile.id]
- to VMSnapshots.list()/.get() added [String allContent] parameter
- to VMs.add() added new overload based on [vm.initialization.configuration.type|data]

* Tue  Aug 6 2013 Michael Pasternak <mpastern@redhat.com> - 1.0.0.17-1
- added root collection StorageConnections
- added [host.override_iptables]
- added [template.cpu_shares]
- added [template.display.single_qxl_pci]
- added [vm.display.single_qxl_pci]
- added [vm.cpu_shares]

* Wed  Jul 31 2013 Michael Pasternak <mpastern@redhat.com> - 1.0.0.16-1
- to template added:
  - [@param template.console.enabled: boolean] #878459
- to vm added:
  - [@param vm.console.enabled: boolean] #878459
- the last character of an error message is truncated #988058

* Thu  Jul 25 2013 Michael Pasternak <mpastern@redhat.com> - 1.0.0.15-1
- to Cluster added:

    * [@param cluster.comment: string]
    * [@param cluster.ballooning_enabled: boolean]
    * [@param cluster.tunnel_migration: boolean]

- to Host added:

    * [@param host.comment: string]
    * [@param host.ssh.port: int]
    * [@param host.ssh.fingerprint: string]
    * [@param host.ssh.authentication_type: string]
    * [@param host.ssh.password: string]
    * forceselectspm() action

- to Network added:

    * [@param network.comment: string]

- to StorageDomain

    * [@param storagedomain.comment: string]

- to Template added:

    * [@param template.comment: string]
    * [@param template.permissions.clone: boolean]

- to VM added:

    * [@param vm.comment: string]
    * [@param vm.permissions.clone: boolean]

* Tue  Jul 16 2013 Michael Pasternak <mpastern@redhat.com> - 1.0.0.14-1
- added "watchdog" feature #947977
- added "external tasks" feature #872719
- snapshot can persist/restore memory state now #960931

* Tue  Jul 9 2013 Michael Pasternak <mpastern@redhat.com> - 1.0.0.13-1
- to cluster.add()/update() added [trusted_service: boolean] property
- move to httpclient 4.2.1
- implement Secure Socket Layer (SSL) host verification (CA certificate)
- allow nullifying headers via passing NULL as header value

* Tue  Jul 2 2013 Michael Pasternak <mpastern@redhat.com> - 1.0.0.12-1
- deploy: require httpclient >= 4.2
- deploy: require jakarta-commons-logging
- deploy: require log4j

* Thu  Jun 27 2013 Michael Pasternak <mpastern@redhat.com> - 1.0.0.11-1
- configure log4j programmatically
- require apache-commons-logging instead of commons-logging

* Wed  Jun 26 2013 Michael Pasternak <mpastern@redhat.com> - 1.0.0.10-1
- to datacenter added new field [comment]
- to disk added [sgio] field to enable|disable filtering for the ScsiGenericIo
- to StorageDomain.delete() added storagedomain.host.id|name

* Thu  Jun 19 2013 Michael Pasternak <mpastern@redhat.com> - 1.0.0.9-1
- implement basic debugging capabilities
- implement support for the /capabilities resource
- added VMApplications sub-collection to VM
- to cluster.update() added [cluster.data_center.id]
- to host.fence() added action.fence_type
- to storagedomain.delete() added [storagedomain.format]
- to nic added [nic.custom_properties.custom_property]
- to vm.add(), vm.update() added [vm.memory_policy.guaranteed]
- to VmPool added MaxUserVMs property

* Thu  Apr 5 2013 Michael Pasternak <mpastern@redhat.com> - 1.0.0.7-1
- first rhevm-sdk-java branded release
- updated storagedomain add()/update() docs
- updated tag update() docs
- enable correct generation of Boolean getters/setters
  to enable Bean Introspection apis (bollean getters will
  be prefixed with getX())
- fixed docs for GlusterBricks add|update
- fixed docs for add|update Tag
- added [network.usages.usage] to ClusterNetworks
- in add TemplateNICs, network.id|name is no longer mandatory
- StorageDomainVM can be removed asynchronously now
- removed DataCenterQuota.add|delete (yet not supported)

* Thu  Apr 4 2013 Michael Pasternak <mpastern@redhat.com> - 1.0.0.6-1
- added new collection ClusterGlusterVolumeGlusterBrickStatistics
- added new properties to the GlusterBrick
- to vm added cpu.mode
- to host install action added "image" parameter
- ignore case in factory method lookup

* Thu  Mar 7 2013 Michael Pasternak <mpastern@redhat.com> - 1.0.0.5-1
- use explicit classloader for JAXBContext
- implement support for (user defined) session authentication
- implement generic JAXBElement generation
- to DataCenterStorageDomain added Disks sub-collection
- to StorageDomain added Disks sub-collection
- to host added display.address property
- to vms.add() added overload for creating vm from snapshot

* Sun  Feb 24 2013 Michael Pasternak <mpastern@redhat.com> - 1.0.0.4-1
- implement SSL support (without host verification)
- implement shutdown() to deallocate system resources
- to cluster added tunnel_migration property
- to DataCenter added Clusters sub-collection
- to root collection resource Disk added Permissions sub-collectio
- to root collection resource Disk added Statistic sub-collection
- host can be attached to cluster now either by id or name
- to StorageDomainTemplate added Disks sub-collection
- to StorageDomainVM added Disks sub-collection
- to template.display added keyboard_layout property
- to template added tunnel_migration property
- to vm.display added keyboard_layout property
- to vm added tunnel_migration property
- to VMSnapshot added preview method
- to VMSnapshot added undo method
- to VMSnapshot added commit method

* Wed  Jan 30 2013 Michael Pasternak <mpastern@redhat.com> - 1.0.0.3-1
- added persistent authentication support
- added support for the method overloads based on url/headers params
- added delete methods overloads with body as parameters holder
- to host added overrideable [display.address] property
- user can specify own ticket now in vm.ticket() via [action.ticket.value]

* Wed  Jan 16 2013 Michael Pasternak <mpastern@redhat.com> - 1.0.0.2-1
- in vm/vmnic device property renamed to reportedDevice
- to host added libvirtVersion
- addresses an issue when API constructor when NULLs used as parameters

* Tue Jan  15 2013 Michael Pasternak <mpastern@redhat.com> - 1.0.0.1-1
- implement parametrized list() methods
- events can be added now (user defined events)
- events can be removed now
- host can be added now by using cluster.name (not only cluster-id)
- NIC now has "linked" property
- NIC now has "plugged" property
- VM has now ReportedDevices sub-collection
- VMNIC has now ReportedDevices sub-collection
- to host add/update added power_management.agents parameter
- to disk added permissions sub-collection
- to PowerManagement added Agents collection
- to VMDisk added move() action
- to host added hooks sub-collection
- to cluster added threads_as_cores property
- to host added hardwareInformation property
- to host added OS property
- added force flag to the host.delete() method
- added host.power_management.pm_proxy sub-collection
- added permissions sub-collection to the network
- added search capabilities to api.networks collection
- added deletion protection support to template/vm via .delete_protected property

* Sun Dec 2 2012 Michael Pasternak <mpastern@redhat.com> - 1.0.0.1-1
- Initial Import
